dhtmlxScheduler와 Svelte 연동

이 가이드는 Svelte의 기본 개념과 패턴에 대한 이해를 전제로 합니다. 만약 익숙하지 않다면, Svelte 공식 문서의 시작하기 튜토리얼을 참고하세요.

DHTMLX Scheduler는 Svelte와 잘 호환됩니다. 동작하는 예제는 GitHub에서 확인할 수 있습니다: DHTMLX Scheduler with Svelte Demo.

프로젝트 생성

새 프로젝트를 만들기 전에 Vite (선택 사항)와 Node.js가 설치되어 있는지 확인하세요.

Vite로 Svelte 프로젝트를 시작하려면 다음 명령어를 실행하세요:

npm create vite@latest

자세한 내용은 관련 문서를 참고하세요.

의존성 설치

다음으로 앱 디렉터리로 이동합니다. 프로젝트 이름을 scheduler-svelte로 하고, svelte 옵션을 선택하세요. 그런 다음 아래 명령어를 실행합니다:

cd scheduler-svelte

이후, 원하는 패키지 매니저로 의존성을 설치하고 앱을 실행하세요:

  • yarn을 사용하는 경우:
yarn install
yarn dev
  • npm을 사용하는 경우:
npm install
npm run dev

Svelte 프로젝트가 http://localhost:5173에서 실행될 것입니다.

Scheduler Svelte app running

Scheduler 생성

DHTMLX Scheduler를 추가하려면 터미널에서 Ctrl+C를 눌러 앱을 중지하세요. 그 다음 Scheduler 패키지를 설치합니다.

1단계. 패키지 설치

라이브러리의 PRO 버전은 npm/yarn을 통해 당사 프라이빗 저장소에서 제공합니다. 액세스하려면 이 안내를 따르세요.

Evaluation 버전을 받았다면 다음과 같이 설치하세요:

  • npm:
npm install @dhx/trial-scheduler
  • yarn:
yarn add @dhx/trial-scheduler

또는, 라이브러리의 zip 패키지는 npm 모듈 구조이므로 로컬 폴더에서 설치할 수도 있습니다.

2단계. 컴포넌트 생성

Scheduler를 앱에 추가하기 위해 새로운 Svelte 컴포넌트를 만듭니다. src/ 디렉터리에 Scheduler.svelte 파일을 생성하세요.

소스 파일 임포트

Scheduler.svelte를 열고 Scheduler 관련 파일을 임포트합니다. 설치 방식에 따라 다릅니다:

  • 로컬 폴더에서 설치한 경우, 임포트는 다음과 같습니다:

Scheduler.svelte

import { Scheduler } from "dhtmlx-scheduler";
import "dhtmlx-scheduler/codebase/dhtmlxscheduler.css";
  • trial 버전을 사용하는 경우, 임포트는 다음과 같습니다:

Scheduler.svelte

import { Scheduler } from "@dhx/trial-scheduler";
import "@dhx/trial-scheduler/codebase/dhtmlxscheduler.css";

이 가이드에서는 trial 버전을 사용합니다.

컨테이너 지정 및 Scheduler 추가

Scheduler를 표시하려면 렌더링할 컨테이너 엘리먼트를 정의해야 합니다. 아래 코드를 참고하세요:

Scheduler.svelte

<script>
    import { onMount } from "svelte";
    import { Scheduler } from "@dhx/trial-scheduler";
    import "@dhx/trial-scheduler/codebase/dhtmlxscheduler.css";
 
    let scheduler;
    let container;
    onMount(() => {
        scheduler = Scheduler.getSchedulerInstance();
        scheduler.skin = "terrace";
        scheduler.init(container, new Date(2023, 9, 6), "week");
 
        return () => scheduler.destructor();
    });
</script>   <div bind:this={container} style="width: 100%; height: 100vh;"></div>

Scheduler 컨테이너가 전체 body를 채우도록 하려면, src/app.css에서 기본 스타일을 제거하고 아래와 같이 추가하세요:

src/app.css

body {
  margin: 0;
  padding: 0;
  height: 100%;
  width: 100%;
}

3단계. 앱에 Scheduler 추가

다음으로 Scheduler 컴포넌트를 앱에 포함합니다. src/App.svelte를 열고 기본 내용을 아래와 같이 교체하세요:

App.svelte

<script>
  import Scheduler from "./Scheduler.svelte";
</script>   <Scheduler/>

앱을 실행하면 빈 Scheduler가 화면에 나타납니다:

Scheduler Svelte init

4단계. 데이터 제공

이벤트를 표시하려면 Scheduler에 데이터를 전달해야 합니다. src/data.js 파일을 만들고 샘플 데이터를 추가하세요:

src/data.js

export function getData() {
    const data = [
        {
            start_date: "2024-06-10 6:00",
            end_date: "2024-06-10 8:00",
            text: "Event 1",
            id: 1,
        },
        {
            start_date: "2024-06-13 10:00",
            end_date: "2024-06-13 18:00",
            text: "Event 2",
            id: 2,
        },
    ];
    return data;
}

그런 다음, 이 데이터를 App.svelte에서 Scheduler 컴포넌트에 prop으로 전달하세요:

App.svelte

<script>
  import Scheduler from "./Scheduler.svelte";
  import { getData } from "./data.js";
</script>   <Scheduler data={getData()} />

Scheduler.svelte 내부에서 scheduler.parse()를 사용해 prop을 적용합니다:

Scheduler.svelte

<script>
    import { onMount } from "svelte";
 
    import { Scheduler } from "@dhx/trial-scheduler";
    import "@dhx/trial-scheduler/codebase/dhtmlxscheduler.css"
    export let data;  
    let scheduler;
    let container;
    onMount(() => {
        scheduler = Scheduler.getSchedulerInstance();
        scheduler.skin = "terrace"
        scheduler.init(container, new Date(2024, 5, 10), "week");
 
        return () => scheduler.destructor();
    });
 
    $: scheduler?.parse(data);
</script>   <div bind:this={container} style="width: 100%; height: 100vh;"></div>

앱을 새로고침하면 이벤트가 표시된 Scheduler가 나타납니다:

Scheduler Svelte events

5단계. 데이터 저장

Scheduler에서 변경된 내용을 처리하려면 dataProcessor 핸들러를 사용하세요. 이 핸들러는 서버 백엔드와의 통신을 가능하게 해줍니다. 핸들러는 함수 또는 라우터 객체가 될 수 있습니다. dhtmlxScheduler는 Promise 응답을 지원하므로, 작업이 올바르게 완료될 때까지 대기합니다.

createDataProcessor()DataProcessor를 생성하고 변경 사항을 다음과 같이 감지할 수 있습니다:

scheduler.createDataProcessor(function(entity, action, data, id) {​
    scheduler.message(`${​entity} ${​action}`);
});

백엔드에서 새 레코드 생성 시 이벤트 ID가 변경되는 경우(일반적인 케이스), Promise가 {id: databaseId} 또는 {tid: databaseId} 객체를 반환해야 Scheduler가 해당 이벤트를 올바르게 갱신할 수 있습니다. 자세한 내용은 서버 사이드 연동을 참고하세요.

이로써 Svelte Scheduler 설정이 완료되었습니다. 전체 데모는 GitHub에서 확인할 수 있습니다: svelte-scheduler-demo.

XSS, CSRF 및 SQL 인젝션 공격

Scheduler 자체는 SQL 인젝션, XSS, CSRF와 같은 위협에 대한 보호 기능을 제공하지 않습니다. 애플리케이션 보안은 백엔드 개발자의 책임입니다.

컴포넌트의 취약점과 권장 보안 대책은 Application Security 문서를 참고하세요.

맨 위로

dhtmlxScheduler와 Angular 연동

이 가이드는 Angular의 기본 개념과 패턴에 대한 이해를 전제로 합니다. 만약 익숙하지 않다면, Angular 공식 문서에서 초보자를 위한 튜토리얼을 참고하는 것이 좋습니다.

DHTMLX Scheduler는 Angular와 매끄럽게 연동됩니다. 실제 예제는 GitHub에서 확인할 수 있습니다: DHTMLX Scheduler with Angular Demo.

프로젝트 생성

새 프로젝트를 시작하기 전에 Angular CLINode.js가 설치되어 있는지 확인하세요. 그런 다음 아래 명령어를 실행합니다:

ng new my-angular-scheduler-app

이 명령어는 필요한 모든 도구와 의존성을 설정해 주므로 추가 단계가 필요하지 않습니다.

의존성 설치

다음으로 앱 폴더로 이동합니다:

cd my-angular-scheduler-app

아래 명령어 중 하나로 앱을 실행할 수 있습니다:

yarn start

또는

npm start

이제 앱은 http://localhost:4200에서 접근 가능합니다.

Scheduler with Angular

Scheduler 생성

DHTMLX Scheduler를 추가하려면, 먼저 실행 중인 앱을 Ctrl+C로 중지하세요. 이후 Scheduler 패키지 설치를 진행합니다.

1단계. 패키지 설치

라이브러리의 PRO 버전은 npm/yarn을 통해 프라이빗 저장소에서 제공됩니다. 이 안내를 따라 접근 권한을 얻으세요.

Evaluation 버전을 받았다면, 다음과 같이 설치합니다:

  • npm:
npm install @dhx/trial-scheduler
  • yarn:
yarn add @dhx/trial-scheduler

또는, 라이브러리의 zip 패키지는 npm 모듈 구조이므로 로컬 폴더에서 설치할 수도 있습니다.

2단계. 컴포넌트 생성

Scheduler를 통합할 새로운 컴포넌트를 만듭니다. src/app/ 디렉터리 내에 scheduler 폴더를 만들고, scheduler.component.ts, scheduler.component.css, scheduler.component.html 파일을 추가하세요.

scheduler.component.html에는 아래와 같이 Scheduler 템플릿을 추가합니다:

scheduler/scheduler.component.html

<div #scheduler_here class="dhx_cal_container" style="width: 100%; height:100vh">
   <div class="dhx_cal_navline">
       <div class="dhx_cal_prev_button"></div>
       <div class="dhx_cal_next_button"></div>
       <div class="dhx_cal_today_button"></div>
       <div class="dhx_cal_date"></div>
       <div class="dhx_cal_tab" data-tab="day"></div>
       <div class="dhx_cal_tab" data-tab="week"></div>
       <div class="dhx_cal_tab" data-tab="month"></div>
   </div>
   <div class="dhx_cal_header"></div>
   <div class="dhx_cal_data"></div>
</div>

Scheduler 스타일은 scheduler.component.css에 별도로 선언합니다. 예시:

scheduler/scheduler.component.css

@import "@dhx/trial-scheduler/codebase/dhtmlxscheduler.css";
:host {
   display: block;
   position: relative;
   height: 100%;
   width: 100%;
}

Scheduler 컨테이너가 전체 body를 채우도록, src 폴더의 styles.css에도 다음 스타일을 추가하세요:

src/styles.css

html,
body {
  margin: 0;
  padding: 0;
  height: 100%;
  width: 100%;
}

소스 파일 임포트

scheduler.component.tsscheduler.component.css에서 Scheduler 소스 파일을 임포트합니다. 설치 방식에 따라 아래와 같습니다:

  • 로컬 폴더에서 설치한 경우, 임포트 예시:

scheduler.component.ts

import { Scheduler, SchedulerStatic } from 'dhtmlx-scheduler';

scheduler.component.css

@import "@dhtmlx-scheduler/codebase/dhtmlxscheduler.css";
  • trial 버전 사용 시, 임포트 예시:

scheduler.component.ts

import { Scheduler, SchedulerStatic } from '@dhx/trial-scheduler';

scheduler.component.css

@import "@dhx/trial-scheduler/codebase/dhtmlxscheduler.css";

이 튜토리얼에서는 trial 버전을 사용합니다.

컨테이너 지정 및 Scheduler 추가

Scheduler를 페이지에 표시하려면, 렌더링할 컨테이너를 지정해야 합니다. 아래 코드를 참고하세요:

scheduler.component.ts

import { Scheduler, SchedulerStatic } from "@dhx/trial-scheduler";
import { Component, ElementRef, OnInit, OnDestroy, 
    ViewChild, ViewEncapsulation } from "@angular/core";
 
@Component({
  encapsulation: ViewEncapsulation.None,
  selector: "scheduler",
  styleUrls: ["./scheduler.component.css"],
  templateUrl: 'scheduler.component.html'
})
 
export class SchedulerComponent implements OnInit, OnDestroy {
  @ViewChild("scheduler_here", { static: true }) schedulerContainer!: ElementRef;
  private _scheduler?: SchedulerStatic;
 
  ngOnInit() {
    let scheduler = Scheduler.getSchedulerInstance();
    scheduler.init(
      this.schedulerContainer.nativeElement,
      new Date(2024, 9, 7),
      "week", 
    );
    this._scheduler = scheduler;
  }
 
  ngOnDestroy() {
    if (this._scheduler) this._scheduler.destructor();
  }
}

여기서 ngOnInit() 라이프사이클 후크는 Scheduler를 초기화하고, ngOnDestroy()에서는 컴포넌트가 파괴될 때 scheduler.destructor()를 호출하여 정리합니다.

3단계. 앱에 Scheduler 추가

다음으로, 기본 내용을 Scheduler 컴포넌트로 교체합니다. src/app/app.component.ts를 열어 다음과 같이 수정합니다:

src/app/app.component.ts

import { Component } from '@angular/core';
 
@Component({
  selector: 'app-root',
  template: `<scheduler></scheduler>`,
})
export class AppComponent {
  name = '';
}

src/app/app.module.ts 파일을 만들고 SchedulerComponent를 포함시킵니다:

src/app/app.module.ts

import { NgModule } from "@angular/core";
import { BrowserModule } from "@angular/platform-browser";
 
import { AppComponent } from "./app.component";
import { SchedulerComponent } from "./scheduler/scheduler.component";
 
@NgModule({
  declarations: [AppComponent, SchedulerComponent],
  imports: [BrowserModule],
  providers: [],
  bootstrap: [AppComponent],
})
export class AppModule {}

마지막으로 src/main.ts 파일의 내용을 아래와 같이 교체합니다:

src/main.ts

import { platformBrowserDynamic } from "@angular/platform-browser-dynamic";
import { AppModule } from "./app/app.module";
 
platformBrowserDynamic()
  .bootstrapModule(AppModule)
  .catch((err) => console.error(err));

앱을 다시 시작하면, 빈 Scheduler가 페이지에 나타납니다.

Adding Scheduler into an app

4단계. 데이터 제공

Angular Scheduler에서 데이터 로딩을 활성화하려면 이벤트 서비스를 추가해야 합니다. 그 전에 이벤트 모델을 정의해야 합니다.

이벤트 모델을 생성하려면 아래 명령어를 사용하세요:

ng generate class models/event --skip-tests

models 폴더 내 새로 생성된 event.ts 파일에 다음 코드를 추가합니다:

models/event.ts

export class Event {
    id!:  number;
    start_date!: string;
    end_date!: string;
    text!: string;
}

다음으로 이벤트 서비스를 생성합니다. 이 서비스는 특정 이벤트를 관리하는 클래스입니다. Angular에서는 서비스를 의존성 주입(Dependency Injection) 방식으로 사용할 수 있습니다. 서비스에는 앱에서 필요한 데이터, 함수 또는 기능이 포함될 수 있습니다. 여기서는 스케줄러에 이벤트를 제공하는 데이터 서비스를 만듭니다.

이벤트 서비스를 생성하려면 아래 명령어를 실행하세요:

ng generate service services/event --flat --skip-tests

services 폴더 내 새로 생성된 event.service.ts 파일에 다음 코드를 추가합니다:

services/event.service.ts

import { Injectable } from '@angular/core';
import { Event } from "../models/event";
 
@Injectable()
export class EventService {
    get(): Promise<Event[]>{
        return Promise.resolve([
            { id: 1, start_date: "2023-05-16 09:00", end_date: "2023-05-16 13:00", 
                text: "Event 1" },
            { id: 2, start_date: "2023-05-18 10:00", end_date: "2023-05-18 14:00", 
                text: "Event 2" },
        ]);
    }
}

@Injectable() 데코레이터는 이 서비스를 주입 가능한 서비스로 표시합니다. 이 서비스는 나중에 컴포넌트에 주입됩니다.

현재 get() 메서드는 하드코딩된 이벤트로 이뤄진 Promise를 반환합니다. 서버에서 데이터를 불러오고 Promise를 반환하도록 확장할 수도 있습니다. 스케줄러 컴포넌트는 EventService를 사용해 이벤트를 가져오게 됩니다. 이를 위해 scheduler.component.ts에서 EventService를 임포트합니다:

scheduler.component.ts

import {EventService} from "../services/event.service";

그리고 @Component 데코레이터에 EventService를 provider로 지정합니다:

scheduler.component.ts

@Component({
  encapsulation: ViewEncapsulation.None,
  selector: "scheduler",
  providers: [EventService],
  styleUrls: ["./scheduler.component.css"],
  templateUrl: 'scheduler.component.html'
})

이렇게 하면 SchedulerComponent가 생성될 때마다 새로운 서비스 인스턴스가 제공됩니다. 서비스 주입을 위해 SchedulerComponent 클래스에 다음과 같이 생성자를 추가합니다:

scheduler.component.ts

constructor(private eventService: EventService){}

ngOnInit() 메서드를 아래와 같이 업데이트하세요:

  • 이벤트 로딩을 위한 날짜 포맷을 설정(XML 포맷 사용)
  • 서비스를 호출해 이벤트를 가져오고, 데이터를 받은 후 스케줄러에 전달

scheduler.component.ts

scheduler.config.date_format = "%Y-%m-%d %H:%i";
scheduler.init(this.schedulerContainer.nativeElement, new Date(2024, 9, 7));
this.eventService.get()
    .then((data) => {
         scheduler.parse(data);
    });

최종 scheduler.component.ts 파일은 아래와 같습니다:

scheduler.component.ts

import { Scheduler, SchedulerStatic } from "@dhx/trial-scheduler";
import { Component, ElementRef, OnInit, OnDestroy, 
    ViewChild, ViewEncapsulation } from "@angular/core";
import {EventService} from "../services/event.service";
 
@Component({
  encapsulation: ViewEncapsulation.None,
  selector: "scheduler",
  providers: [EventService],
  styleUrls: ['scheduler.component.css'],
  templateUrl: 'scheduler.component.html'
})
 
export class SchedulerComponent implements OnInit, OnDestroy {
  @ViewChild("scheduler_here", { static: true }) schedulerContainer!: ElementRef;
  private _scheduler?: SchedulerStatic;
  constructor(private eventService: EventService) { }
 
  ngOnInit() {
    let scheduler = Scheduler.getSchedulerInstance();
    scheduler.config.date_format = "%Y-%m-%d %H:%i";
    scheduler.init(
      this.schedulerContainer.nativeElement,
      new Date(2024, 9, 7),
      "week", 
    );
    this.eventService.get().then((data) => {scheduler.parse(data);});
    this._scheduler = scheduler;
  }
 
  ngOnDestroy() {
    if (this._scheduler) this._scheduler.destructor();
  }
}

앱 페이지를 다시 열면 Scheduler에 이벤트가 표시됩니다.

Scheduler with Angular events

5단계. 데이터 저장

Scheduler에서 변경 사항을 추적하려면, 백엔드와 통신하기 위해 dataProcessor 핸들러를 사용할 수 있습니다. 이 핸들러는 함수 또는 라우터 객체로 정의할 수 있습니다. dhtmlxScheduler는 핸들러에서 Promise 응답을 지원하므로, 작업이 올바르게 처리됩니다.

DataProcessorcreateDataProcessor() API 메서드를 사용하여 다음과 같이 변경 사항을 감지할 수 있습니다:

scheduler.createDataProcessor(function(entity, action, data, id) {​
    scheduler.message(`${​entity} ${​action}`);
});

서비스가 새 레코드를 생성한 후 이벤트 ID를 수정하는 경우(일반적임), Promise는 {id: databaseId} 또는 {tid: databaseId} 형태의 객체를 반환해야 합니다. 이렇게 하면 Scheduler가 새 데이터베이스 ID로 레코드를 업데이트할 수 있습니다.

서버 측 통합에 대한 자세한 내용은 여기에서 확인할 수 있습니다.

이제 Angular Scheduler 설정이 완료되었습니다. GitHub에서 전체 데모를 확인해보세요.

XSS, CSRF 및 SQL 인젝션 공격

Scheduler 자체는 SQL 인젝션, XSS 또는 CSRF 공격과 같은 위협에 대한 보호 기능을 제공하지 않습니다. 애플리케이션 보안은 백엔드 개발자의 책임입니다.

잠재적인 취약점 및 권장 보안 관행에 대한 자세한 내용은 Application Security 문서를 참고하세요.

맨 위로

dhtmlxScheduler와 React

이 가이드는 React의 기본 개념과 패턴에 대한 이해가 있다고 가정합니다. React가 처음이라면 React 공식 문서에서 입문 튜토리얼을 먼저 참고하는 것이 좋습니다.

DHTMLX Scheduler는 React와 잘 호환됩니다. 관련 예제는 GitHub에서 확인할 수 있습니다: DHTMLX Scheduler with React Demo.

프로젝트 생성

프로젝트를 생성하기 전에 Node.js가 설치되어 있는지 확인하세요.

간단한 React 프로젝트를 설정하려면 다음 명령어를 실행하세요:

npx create-vite my-react-scheduler-app --template react

의존성 설치

다음으로, 앱 디렉토리로 이동합니다. 이 예제에서는 my-react-scheduler-app을 사용합니다:

cd my-react-scheduler-app

그런 다음, 원하는 패키지 매니저를 사용하여 의존성을 설치하고 개발 서버를 시작하세요:

  • yarn을 사용하는 경우:
yarn install
yarn dev
  • npm을 사용하는 경우:
npm install
npm run dev

React 프로젝트가 http://localhost:5173에서 실행되고 있어야 합니다.

Scheduler React app running

Scheduler 생성

DHTMLX Scheduler를 추가하려면, 먼저 명령줄에서 Ctrl+C를 눌러 앱을 중지하세요. 이후 Scheduler 패키지를 설치합니다.

1단계. 패키지 설치

라이브러리의 PRO 버전은 당사 프라이빗 저장소에서 npm/yarn을 통해 제공됩니다. 접근 방법은 이 안내를 참고하세요.

Scheduler의 Evaluation 버전을 받았다면, 다음 명령어 중 하나로 설치하세요:

  • npm 사용 시:
npm install @dhx/trial-scheduler
  • yarn 사용 시:
yarn add @dhx/trial-scheduler

또는, 라이브러리의 zip 패키지는 npm 모듈 구조이므로 로컬 폴더에서 설치할 수도 있습니다.

2단계. 컴포넌트 생성

이제 React 컴포넌트를 만들어 앱에 Scheduler를 추가합니다. src/components/Scheduler 폴더를 만들고, 그 안에 Scheduler.jsx, Scheduler.css, index.js 파일을 생성하세요.

먼저 scheduler-container 스타일을 적용할 Scheduler.css를 만듭니다:

src/components/Scheduler/Scheduler.css

.scheduler-container {
    height: 100vh;
    width: 100vw;
}

Scheduler 컨테이너가 body 전체를 채우도록 하려면, src 폴더의 App.css에서 기본 스타일을 제거하고 다음을 추가하세요:

#root {
  margin: 0;
  padding: 0;
  height: 100%;
  width: 100%;
}

그런 다음 index.js 파일에 아래 내용을 추가합니다:

src/components/Scheduler/index.js

import Scheduler from './Scheduler';
import './Scheduler.css';
export default Scheduler;

소스 파일 임포트

Scheduler.jsx를 열고 Scheduler 소스 파일을 임포트합니다. 패키지 설치 방식에 따라 임포트 경로가 달라질 수 있습니다:

  • 로컬 폴더에서 설치한 경우:

Scheduler.jsx

import { Scheduler } from 'dhtmlx-scheduler';
import 'dhtmlx-scheduler/codebase/dhtmlxscheduler.css';
  • trial 버전 사용 시:

Scheduler.jsx

import { Scheduler } from '@dhx/trial-scheduler';
import '@dhx/trial-scheduler/codebase/dhtmlxscheduler.css';

이 튜토리얼에서는 trial 버전을 사용합니다.

컨테이너 설정 및 Scheduler 추가

Scheduler를 페이지에 렌더링하려면 컨테이너를 설정해야 합니다. Scheduler.jsx에 다음 코드를 작성하세요:

src/components/Scheduler/Scheduler.jsx

import { useEffect, useRef } from "react";
import { Scheduler } from "@dhx/trial-scheduler";
import "@dhx/trial-scheduler/codebase/dhtmlxscheduler.css";
 
export default function SchedulerView( ) {
    let container = useRef();
    useEffect(() => {
        let scheduler = Scheduler.getSchedulerInstance();
        scheduler.skin = "terrace";
        scheduler.config.header = [
            "day",
            "week",
            "month",
            "date",
            "prev",
            "today",
            "next",
        ];
 
        scheduler.init(container.current, new Date(2024, 5, 10));
        return () => {
            scheduler.destructor();
            container.current.innerHTML = "";
        };
    }, []);
 
    return (
        <div ref={container} style=width: "100%", height: "100%"></div>
    );
}

3단계. 앱에 Scheduler 추가

이제 Scheduler 컴포넌트를 앱에 추가합니다. src/App.jsx를 열고 기본 내용을 다음으로 교체하세요:

src/App.jsx

import Scheduler from "./components/Scheduler";
import "./App.css";
 
function App() {
    return (
        <div className="scheduler-container">
            <Scheduler/>
        </div>
    );
}
export default App;

앱을 다시 실행하면 빈 Scheduler가 페이지에 표시됩니다:

Scheduler React init

4단계. 데이터 제공

Scheduler에 일정을 표시하려면 데이터셋을 제공해야 합니다. src/ 디렉토리에 data.js를 생성하고 몇 가지 이벤트를 추가하세요:

src/data.js

export function getData() {
    const data = [
        {
            start_date: "2024-06-10 6:00",
            end_date: "2024-06-10 8:00",
            text: "Event 1",
            id: 1,
        },
        {
            start_date: "2024-06-13 10:00",
            end_date: "2024-06-13 18:00",
            text: "Event 2",
            id: 2,
        },
    ];
    return data;
}

그런 다음, 이 데이터를 App.jsx에서 Scheduler 컴포넌트에 props로 전달합니다:

App.jsx

import { getData } from "./data.js";
import Scheduler from "./components/Scheduler";
import "./App.css";
 
function App() {
    return (
        <div className="scheduler-container">
            <Scheduler events={getData()}/>
        </div>
    );
}
export default App;

Scheduler 컴포넌트 내에서 scheduler.parse() 메서드에 props를 사용하세요:

Scheduler.jsx

import { useEffect, useRef } from "react";
import { Scheduler } from "@dhx/trial-scheduler";
import "@dhx/trial-scheduler/codebase/dhtmlxscheduler.css";
 
export default function SchedulerView({events}) {
    let container = useRef();
    useEffect(() => {
        let scheduler = Scheduler.getSchedulerInstance();
        scheduler.skin = "terrace";
        scheduler.config.header = [
            "day",
            "week",
            "month",
            "date",
            "prev",
            "today",
            "next",
        ];
 
        scheduler.init(container.current, new Date(2024, 5, 10));
        scheduler.parse(events);
        return () => {
            scheduler.destructor();
            container.current.innerHTML = "";
        };
    }, []);
 
    return (
        <div ref={container} style=width: "100%", height: "100%"></div>
    );
}

이제 앱 페이지를 새로고침하면 이벤트가 로드된 Scheduler가 표시됩니다:

Scheduler React events

5단계. 데이터 저장

Scheduler에서 변경된 내용을 처리하려면 dataProcessor 핸들러를 사용할 수 있습니다. 이를 통해 서버 백엔드와 통신할 수 있습니다. 핸들러는 함수 또는 라우터 객체가 될 수 있습니다. dhtmlxScheduler는 핸들러의 Promise 응답도 지원하므로, 작업 완료 처리가 올바르게 이루어집니다.

createDataProcessor()를 사용하여 DataProcessor를 생성하고 다음과 같이 변경 사항을 감지할 수 있습니다:

scheduler.createDataProcessor(function(entity, action, data, id) {​
    scheduler.message(`${​entity} ${​action}`);
});

백엔드에서 새 항목을 생성한 후 이벤트 id가 변경되는 경우(일반적임), Promise에서 {id: databaseId} 또는 {tid: databaseId} 객체를 반환해야 합니다. 이렇게 하면 Scheduler가 새 데이터베이스 id로 레코드를 업데이트할 수 있습니다. 자세한 내용은 server side integration을 참고하세요.

이로써 React Scheduler 설정이 완료되었습니다. 전체 데모는 GitHub에서 확인할 수 있습니다: DHTMLX react-scheduler-demo.

XSS, CSRF 및 SQL Injection 공격

Scheduler 자체는 SQL 인젝션, XSS, CSRF 공격과 같은 위협에 대한 보호 기능을 제공하지 않습니다. 이러한 위험으로부터 애플리케이션을 보호하는 것은 백엔드 개발자의 책임입니다.

일반적인 취약점과 보안 강화 방법은 Application Security 문서를 참고하세요.

맨 위로

dhtmlxScheduler와 Vue.js

이 가이드는 Vue의 기본 개념과 패턴을 이해하고 있다고 가정합니다. 복습이 필요하다면, Vue 3 공식 문서에서 유용한 시작 튜토리얼을 참고할 수 있습니다.

DHTMLX Scheduler는 Vue와 원활하게 작동합니다. 관련 예제는 GitHub에서 확인할 수 있습니다: DHTMLX Scheduler with Vue Demo.

프로젝트 생성

새 프로젝트를 시작하기 전에 Node.js가 설치되어 있는지 확인하세요.

Vue 프로젝트를 생성하려면 다음 명령어를 실행하세요:

npm create vue@latest

이 명령어는 공식 Vue 프로젝트 스캐폴딩 도구인 create-vue를 설치하고 실행합니다. 자세한 내용은 Vue.js Quick Start를 참고하세요.

의존성 설치

다음으로 앱 디렉토리로 이동합니다. 이 가이드에서는 프로젝트 이름을 scheduler-vue로 지정하고 다음을 실행합니다:

cd scheduler-vue

그런 다음, 패키지 매니저를 사용하여 의존성을 설치하고 개발 서버를 시작합니다:

  • yarn을 사용하는 경우:
yarn install
yarn dev
  • npm을 사용하는 경우:
npm install
npm run dev

이제 Vue 프로젝트가 http://localhost:5173에서 접근 가능합니다.

Scheduler Vue.js app running

Scheduler 생성

Scheduler를 추가하기 전에, 터미널에서 Ctrl+C를 눌러 실행 중인 앱을 중지하세요. 이후 Scheduler 패키지 설치를 진행합니다.

1단계. 패키지 설치

PRO 버전 라이브러리는 npm/yarn을 통해 당사 프라이빗 저장소에서 제공됩니다. 접근 권한을 얻으려면 이 안내를 따르세요.

Scheduler의 Evaluation 버전을 받았다면, 다음과 같이 설치할 수 있습니다:

  • npm:
npm install @dhx/trial-scheduler
  • yarn:
yarn add @dhx/trial-scheduler

또는, 라이브러리 zip 패키지가 npm 모듈 구조이므로 로컬 폴더에서 설치할 수도 있습니다.

2단계. 컴포넌트 생성

Scheduler를 앱에 통합하기 위해 Vue 컴포넌트를 생성합니다. src/components/ 디렉토리에 Scheduler.vue 파일을 새로 만드세요.

소스 파일 임포트

Scheduler.vue를 열고 Scheduler 소스 파일을 임포트합니다. 설치 방식에 따라 다음과 같이 다릅니다:

  • 로컬 폴더 설치 시 임포트 예시:

Scheduler.vue

import { Scheduler } from "dhtmlx-scheduler";<style>
  @import "@dhtmlx-scheduler/codebase/dhtmlxscheduler.css";
</style>
  • trial 버전 사용 시 임포트 예시:

Scheduler.vue

import { Scheduler } from "@dhx/trial-scheduler";<style>
  @import "@dhx/trial-scheduler/codebase/dhtmlxscheduler.css";
</style>

이 튜토리얼에서는 trial 버전의 Scheduler를 사용합니다.

컨테이너 설정 및 Scheduler 추가

Scheduler를 페이지에 렌더링하려면 컨테이너 엘리먼트를 지정해야 합니다. 관련 코드는 다음과 같습니다:

Scheduler.vue

<script>
import { Scheduler } from "@dhx/trial-scheduler";
import "@dhx/trial-scheduler/codebase/dhtmlxscheduler.css";
 
export default {
  mounted() {
    let scheduler = Scheduler.getSchedulerInstance();
    let date = scheduler.init(this.$refs.cont, new Date(2023, 9, 6), "week");
    this.scheduler = scheduler;
  },
  unmounted() {
    this.scheduler.destructor();
    this.$refs.cont.innerHTML = "";
  },
};
</script>   <template> <div ref="cont" style="width: 100%; height: 100vh"></div> </template>

Scheduler 컨테이너가 전체 body를 채우도록 하려면, src/assets 폴더의 main.css에서 기본 스타일을 제거하고 아래와 같이 교체하세요:

src/assets/main.css

#app {
  margin: 0;
  padding: 0;
  height: 100%;
  width: 100%;
}

3단계. 앱에 Scheduler 추가

다음으로 Scheduler 컴포넌트를 앱에 추가합니다. src/App.vue를 열고 기본 내용을 아래와 같이 교체하세요:

src/App.vue

<script>
import Scheduler from "./components/Scheduler.vue";
 
export default {
  components: { Scheduler },
};
</script>   <template> <Scheduler/> </template>

앱을 실행하면 페이지에 빈 Scheduler가 표시됩니다:

Scheduler Vue init

4단계. 데이터 제공

Scheduler에 이벤트를 표시하려면 데이터를 공급해야 합니다. src/ 디렉토리에 data.js 파일을 만들고 샘플 이벤트를 추가하세요:

src/data.js

export function getData() {
    const data = [
        {
            start_date: "2024-06-10 6:00",
            end_date: "2024-06-10 8:00",
            text: "Event 1",
            id: 1,
        },
        {
            start_date: "2024-06-13 10:00",
            end_date: "2024-06-13 18:00",
            text: "Event 2",
            id: 2,
        },
    ];
    return data;
}

이 데이터를 App.vue에서 Scheduler 컴포넌트의 props로 전달합니다:

App.vue

<script>
import Scheduler from "./components/Scheduler.vue";
import { getData } from "./data";
 
export default {
  components: { Scheduler },
  data() {
    return {
      events: getData(),
    };
  },
};
</script>   <template> <Scheduler :events="events" /> </template>

그리고 Scheduler 컴포넌트 내에서 scheduler.parse() 메서드에 props를 사용하세요:

Scheduler.vue

<script>
import { Scheduler } from "@dhx/trial-scheduler";
import "@dhx/trial-scheduler/codebase/dhtmlxscheduler.css";
 
export default {
  props: ["events"],
  mounted() {
    let scheduler = Scheduler.getSchedulerInstance();
    let date = scheduler.init(this.$refs.cont, new Date(2023, 5, 10), "week");
    scheduler.parse(this.events);
 
    this.scheduler = scheduler;
  },
  unmounted() {
    this.scheduler.destructor();
    this.$refs.cont.innerHTML = "";
  },
};
</script>   <template> <div ref="cont" style="width: 100%; height: 100vh"></div> </template>

앱 페이지를 새로고침하면 이벤트가 표시된 Scheduler가 나타납니다:

Scheduler Vue events

5단계. 데이터 저장

Scheduler 내에서 발생하는 변경 사항을 추적하려면, dataProcessor 핸들러를 사용할 수 있습니다. 이 핸들러는 서버 백엔드와의 통신을 도와줍니다. 함수 혹은 라우터 객체로 정의할 수 있으며, dhtmlxScheduler는 handler에서 Promise 응답을 지원하므로 액션 완료를 올바르게 처리할 수 있습니다.

createDataProcessor() API 메서드를 사용하여 DataProcessor를 생성하고, 아래와 같이 변경 사항을 감지할 수 있습니다:

scheduler.createDataProcessor(function(entity, action, data, id) {​
    scheduler.message(`${​entity} ${​action}`);
});

백엔드에서 새 레코드를 생성 후 이벤트 ID를 변경하는 경우(일반적인 시나리오), Promise에서 {id: databaseId} 또는 {tid: databaseId}를 반환해야 합니다. 이렇게 하면 Scheduler가 데이터베이스의 새 ID로 레코드를 업데이트할 수 있습니다. 자세한 내용은 server side integration을 참고하세요.

이제 Vue Scheduler 설정이 완료되었습니다. 전체 데모는 GitHub에서 확인할 수 있습니다: https://github.com/DHTMLX/vue-scheduler-demo.

XSS, CSRF 및 SQL 인젝션 공격

Scheduler 자체는 SQL 인젝션, XSS, CSRF 공격과 같은 위협에 대한 보호 기능을 제공하지 않습니다. 애플리케이션 보안은 개발자, 특히 백엔드 구현자의 책임입니다.

컴포넌트의 취약점을 이해하고 애플리케이션의 보안을 강화하는 방법은 Application Security 문서를 참고하세요.

맨 위로